<?php
/**
 * @file
 * Contains an example of a client script.
 */

// This is the composer autoload file loading the PHP-Hawk library used
// throughout the file. Fix the path according to your setup.
require_once 'vendor/autoload.php';

// Note: Drupal 8 recently changed REST format to follow _format=json at the
// end of URL instead of Accept: application/json in the headers.
$request_url = 'http://example.com/drupal/node/1?_format=json';
$method = 'GET';

// Credentials generated by Hawk authentication module.
$credentials = new \Dragooon\Hawk\Credentials\Credentials(
  // Key Secret.
  'LAMqXvfADLJMsba5UZwx4VrWmsoLRvYX',
  // Key Algorithm.
  'sha256',
  // Key ID, this is separate from User ID and is listed alongside Key Secret.
  1
);

$client = \Dragooon\Hawk\Client\ClientBuilder::create()->build();
$request = $client->createRequest(
  $credentials,
  $request_url,
  $method,
  []
);

$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, $request_url);
curl_setopt($ch, CURLOPT_VERBOSE, TRUE);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, FALSE);
curl_setopt($ch, CURLOPT_HEADER, TRUE);

// Pass the Authorization header in order to identify the user.
curl_setopt($ch, CURLOPT_HTTPHEADER, array(
  $request->header()->fieldName() . ': ' . $request->header()->fieldValue(),
));

$response = curl_exec($ch);

curl_close($ch);

echo $response;
